package cz.muni.fi.pv168.swing;

import cz.muni.fi.pv168.books.Book;
import cz.muni.fi.pv168.books.BookManager;
import cz.muni.fi.pv168.books.SpringConfig;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.awt.*;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;

/**
 * Created by makub on 5/7/14.
 */
public class MainForm {
    private JTabbedPane tabbedPane1;
    private JPanel panel1;
    private JButton createButton;
    private JButton updateButton;
    private JButton deleteButton;
    private JTable table1;

    final static Logger log = LoggerFactory.getLogger(MainForm.class);

    static ResourceBundle texts = ResourceBundle.getBundle("Texts");
    private BookManager bookManager;
    private BooksTableModel booksTableModel;

    public MainForm() {
        super();
        log.debug("new MainForm()");
        deleteButton.addActionListener((e) -> {
            int row = table1.convertRowIndexToModel(table1.getSelectedRow());
            booksTableModel.deleteBookForRow(row);
        });

    }

    public static void main(String[] args) {
        log.info("zaciname");

        EventQueue.invokeLater(() -> {
            // Vytvoříme instanci třídy Frame, která reprezentuje okno
            JFrame frame = new JFrame();
            // Zajistíme, aby se po zavření okna ukončila i aplikace
            frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
            // Nastavíme titulek okna
            frame.setTitle(texts.getString("window_title"));
            MainForm mainForm = new MainForm();
            mainForm.panel1.setPreferredSize(new Dimension(800,600));
            frame.setContentPane(mainForm.panel1);
            frame.pack();
            // Zobrazíme okno
            frame.setVisible(true);
        });
    }

    private void createUIComponents() {
        log.debug("createUIComponents()");
        ApplicationContext ctx = new AnnotationConfigApplicationContext(SpringConfig.class);
        bookManager = ctx.getBean("bookManager", BookManager.class);

        booksTableModel = new BooksTableModel(bookManager);
        table1 = new JTable(booksTableModel);
        ListSelectionModel selectionModel = table1.getSelectionModel();
        selectionModel.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        selectionModel.addListSelectionListener((e) -> {
            if(table1.getSelectedRowCount()==1) {
                deleteButton.setEnabled(true);
                updateButton.setEnabled(true);
            } else {
                deleteButton.setEnabled(false);
                updateButton.setEnabled(false);
            }
        });
    }
}
